import _toConsumableArray from "C:\\_\\react-vt-table\\node_modules\\babel-preset-react-app\\node_modules\\@babel\\runtime/helpers/esm/toConsumableArray";
import _classCallCheck from "C:\\_\\react-vt-table\\node_modules\\babel-preset-react-app\\node_modules\\@babel\\runtime/helpers/esm/classCallCheck";
import _possibleConstructorReturn from "C:\\_\\react-vt-table\\node_modules\\babel-preset-react-app\\node_modules\\@babel\\runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "C:\\_\\react-vt-table\\node_modules\\babel-preset-react-app\\node_modules\\@babel\\runtime/helpers/esm/getPrototypeOf";
import _createClass from "C:\\_\\react-vt-table\\node_modules\\babel-preset-react-app\\node_modules\\@babel\\runtime/helpers/esm/createClass";
import _inherits from "C:\\_\\react-vt-table\\node_modules\\babel-preset-react-app\\node_modules\\@babel\\runtime/helpers/esm/inherits";
import React from 'react';
import { VariableSizeList as List } from 'react-window';
import * as Immutable from 'immutable';
import classNames from 'classnames';
import Header from '../Header/Header';
import Row from '../Row/Row';
import Column from '../Column/Column';
import memoize from 'memoize-one';

var countChildren = function countChildren(children) {
  var count = 0;
  React.Children.forEach(children, function (child) {
    if (child) {
      count += 1;
    }
  });
  return count;
};

var getItemData = memoize(function (dataList, rowProps) {
  return {
    dataList: dataList,
    rowProps: rowProps
  };
});

var Table =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Table, _React$Component);

  _createClass(Table, [{
    key: "calculateCustomColumnsWidth",
    value: function calculateCustomColumnsWidth() {
      var _this$props = this.props,
          children = _this$props.children,
          overflowWidth = _this$props.overflowWidth,
          width = _this$props.width,
          minColumnWidth = _this$props.minColumnWidth,
          dynamicColumnWidth = _this$props.dynamicColumnWidth;
      var customColumnsWidth = [];
      var customColumnsCount = 0;
      var customColumnsWidthSum = 0;
      React.Children.forEach(children, function (child) {
        if (!child) {
          return;
        }

        var width = child.props.width;

        if (Number.isInteger(width)) {
          width = Math.max(width, minColumnWidth);
          customColumnsCount += 1;
          customColumnsWidthSum += width;
        }

        customColumnsWidth.push(width || undefined);
      });

      if (!dynamicColumnWidth) {
        //Fill other width averaged width values
        var defaultWidth = Math.max((width - overflowWidth - customColumnsWidthSum) / (this.getColumnsCount() - customColumnsCount), minColumnWidth);
        customColumnsWidth = customColumnsWidth.map(function (item) {
          if (item === undefined) {
            return defaultWidth;
          }

          return item;
        });
      }

      return customColumnsWidth;
    }
  }, {
    key: "componentWillUpdate",
    value: function componentWillUpdate() {
      this.rowWidth = null;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (countChildren(prevProps.children) !== countChildren(this.props.children)) {
        this.setState({
          customColumnsWidth: this.calculateCustomColumnsWidth()
        });
      }

      if (this.autoScrolling && this.props.autoScroll && this.props.data) {
        this.scrollToItem(this.props.data.size);
      }
    }
  }]);

  function Table(props) {
    var _this;

    _classCallCheck(this, Table);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Table).call(this, props));
    _this.state = {
      customColumnsWidth: []
    };
    _this.autoScrolling = _this.props.autoScroll;
    _this.rowWidth = null;

    _this.getColumnWidth = function (columnIndex) {
      var _this$props2 = _this.props,
          width = _this$props2.width,
          overflowWidth = _this$props2.overflowWidth,
          minColumnWidth = _this$props2.minColumnWidth,
          dynamicColumnWidth = _this$props2.dynamicColumnWidth;
      var customColumnsWidth = _this.state.customColumnsWidth;

      if (!dynamicColumnWidth) {
        return customColumnsWidth[columnIndex];
      }

      if (customColumnsWidth[columnIndex]) {
        return customColumnsWidth[columnIndex];
      }

      var customColumnsWidthSum = 0;
      var customColumnsCount = 0;
      customColumnsWidth.forEach(function (item) {
        if (item) {
          customColumnsCount += 1;
          customColumnsWidthSum += item;
        }
      });
      return Math.max((width - overflowWidth - customColumnsWidthSum) / (_this.getColumnsCount() - customColumnsCount), minColumnWidth);
    };

    _this.getRowHeight = function (index) {
      var rowHeight = _this.props.rowHeight;

      if (typeof rowHeight === 'function') {
        return rowHeight(index);
      }

      return rowHeight;
    };

    _this.getEstimatedItemSize = function () {
      var data = _this.props.data;
      var total = data.reduce(function (total, item, idx) {
        return total + _this.getRowHeight(idx);
      }, 0);
      return Math.floor(total / _this.getDataSize());
    };

    _this.getHeaderHeight = function () {
      var _this$props3 = _this.props,
          headerHeight = _this$props3.headerHeight,
          disableHeader = _this$props3.disableHeader;

      if (disableHeader) {
        return 0;
      }

      if (typeof headerHeight === 'function') {
        return headerHeight();
      }

      return headerHeight;
    };

    _this.getRowData = function (index, data) {
      data = data || _this.props.data;

      if (Immutable && Immutable.Iterable.isIterable(data)) {
        return data.get(index);
      } else {
        return data[index];
      }
    };

    _this.getCellValue = function (_ref) {
      var rowData = _ref.rowData,
          dataKey = _ref.dataKey;

      if (Immutable && Immutable.Iterable.isIterable(rowData)) {
        return rowData.get(dataKey);
      } else {
        return rowData[dataKey];
      }
    };

    _this.getDataSize = function () {
      var data = _this.props.data;

      if (Immutable && Immutable.Iterable.isIterable(data)) {
        return data.size;
      } else {
        return data.length;
      }
    };

    _this.getRowWidth = function () {
      var customColumnsWidth = _this.state.customColumnsWidth;

      if (_this.rowWidth === null) {
        _this.rowWidth = customColumnsWidth.reduce(function (result, item, idx) {
          return result + _this.getColumnWidth(idx);
        }, 0);
      }

      return _this.rowWidth;
    };

    _this.handleResizeColumn = function (columnIndex, diff, dataKey) {
      var _this$props4 = _this.props,
          minColumnWidth = _this$props4.minColumnWidth,
          maxColumnWidth = _this$props4.maxColumnWidth,
          onResizeColumn = _this$props4.onResizeColumn;
      var customColumnsWidth = _this.state.customColumnsWidth;

      var columnWidth = _this.getColumnWidth(columnIndex);

      var newCustomColumnsWidth = _toConsumableArray(customColumnsWidth);

      var newWidth = Math.max(columnWidth + diff, minColumnWidth);

      if (maxColumnWidth) {
        newWidth = Math.min(newCustomColumnsWidth[columnIndex], maxColumnWidth);
      }

      newCustomColumnsWidth[columnIndex] = newWidth;

      _this.setState({
        customColumnsWidth: newCustomColumnsWidth
      });

      _this.list && _this.list.resetAfterIndex(0);
      onResizeColumn({
        dataKey: dataKey,
        columnIndex: columnIndex,
        resizeDiff: diff,
        newWidth: newWidth
      });
    };

    _this.getRowHandler = function (actionType) {
      if (!_this["handleRow".concat(actionType)]) {
        _this["handleRow".concat(actionType)] = function (event) {
          var action = _this.props["onRow".concat(actionType)];

          if (action) {
            var rowIndex = Number(event.currentTarget.dataset.rowIndex);

            var rowData = _this.getRowData(rowIndex);

            action(event, {
              rowIndex: rowIndex,
              rowData: rowData
            });
          }
        };
      }

      return _this["handleRow".concat(actionType)];
    };

    _this.handleScroll = function (_ref2) {
      var scrollDirection = _ref2.scrollDirection,
          scrollOffset = _ref2.scrollOffset,
          scrollUpdateWasRequested = _ref2.scrollUpdateWasRequested;
      var onScroll = _this.props.onScroll; //react-window fires onScroll every time on mount, fixing it using this condition

      if (!(!onScroll || scrollDirection === 'forward' && scrollOffset === 0 && !scrollUpdateWasRequested)) {
        onScroll({
          scrollDirection: scrollDirection,
          scrollOffset: scrollOffset,
          scrollUpdateWasRequested: scrollUpdateWasRequested
        });
      }

      if (_this.props.autoScroll && !scrollUpdateWasRequested) {
        var scrollHeight = _this.listOuter.scrollHeight;
        var clientHeight = _this.listOuter.offsetHeight;
        _this.autoScrolling = scrollHeight === clientHeight + scrollOffset;
      }
    };

    _this.state.customColumnsWidth = _this.calculateCustomColumnsWidth();
    return _this;
  }

  _createClass(Table, [{
    key: "getColumnsCount",
    value: function getColumnsCount() {
      var children = this.props.children;
      var total = 0;
      React.Children.forEach(children, function (child) {
        if (child && child.type === Column) {
          total += 1;
        }
      });
      return total;
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      var disableHeader = this.props.disableHeader;

      if (!disableHeader) {
        this.listOuter && this.listOuter.addEventListener('scroll', function (e) {
          _this2.header.headerEl.scrollLeft = e.target.scrollLeft;
        });
      }
    }
  }, {
    key: "scrollTo",
    value: function scrollTo(scrollOffset) {
      this.list && this.list.scrollTo(scrollOffset);
    }
  }, {
    key: "scrollToItem",
    value: function scrollToItem(index, align) {
      this.list && this.list.scrollToItem(index, align);
    }
  }, {
    key: "renderHeader",
    value: function renderHeader() {
      var _this3 = this;

      var _this$props5 = this.props,
          children = _this$props5.children,
          disableHeader = _this$props5.disableHeader,
          headerHeight = _this$props5.headerHeight,
          sortIndicatorRenderer = _this$props5.sortIndicatorRenderer,
          overflowWidth = _this$props5.overflowWidth;

      if (disableHeader) {
        return null;
      }

      var componentProps = {
        children: children,
        overflowWidth: overflowWidth,
        height: headerHeight,
        getColumnWidth: this.getColumnWidth,
        getHeaderHeight: this.getHeaderHeight,
        onResizeColumn: this.handleResizeColumn,
        onClick: this.props.onHeaderClick,
        onDoubleClick: this.props.onHeaderDoubleClick,
        onMouseOver: this.props.onHeaderMouseOver,
        onMouseOut: this.props.onHeaderMouseOut,
        onRightClick: this.props.onHeaderRightClick,
        sortIndicatorRenderer: sortIndicatorRenderer,
        ref: function ref(i) {
          return _this3.header = i;
        }
      };
      return React.createElement(Header, componentProps);
    }
  }, {
    key: "renderRow",
    value: function renderRow() {
      var rowRenderer = this.props.rowRenderer;
      return rowRenderer ? rowRenderer : Row;
    }
  }, {
    key: "renderNoItemsLabel",
    value: function renderNoItemsLabel() {
      var noItemsLabel = this.props.noItemsLabel;
      return React.createElement("div", {
        className: "VTNoItemsLabel"
      }, noItemsLabel);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props6 = this.props,
          height = _this$props6.height,
          width = _this$props6.width,
          listProps = _this$props6.listProps,
          className = _this$props6.className,
          data = _this$props6.data,
          rowClassName = _this$props6.rowClassName,
          children = _this$props6.children;
      var rowProps = {
        children: children,
        rowClassName: rowClassName,
        getRowData: this.getRowData,
        getRowWidth: this.getRowWidth,
        getCellValue: this.getCellValue,
        getColumnWidth: this.getColumnWidth,
        onClick: this.getRowHandler('Click'),
        onDoubleClick: this.getRowHandler('DoubleClick'),
        onMouseOver: this.getRowHandler('MouseOver'),
        onMouseOut: this.getRowHandler('MouseOut'),
        onMouseDown: this.getRowHandler('MouseDown'),
        onMouseUp: this.getRowHandler('MouseUp'),
        onRightClick: this.getRowHandler('RightClick')
      };
      var itemData = getItemData(data, rowProps);
      return React.createElement("div", {
        className: classNames('VTContainer', className),
        style: {
          paddingTop: this.getHeaderHeight(),
          width: width,
          height: height - this.getHeaderHeight()
        }
      }, this.renderHeader(), this.getDataSize() ? React.createElement(List, Object.assign({
        ref: function ref(i) {
          return _this4.list = i;
        },
        innerRef: function innerRef(i) {
          return _this4.listInner = i;
        },
        outerRef: function outerRef(i) {
          return _this4.listOuter = i;
        },
        className: "VTList",
        height: height - this.getHeaderHeight(),
        itemCount: this.getDataSize(),
        itemSize: this.getRowHeight,
        itemData: itemData,
        width: width,
        onScroll: this.handleScroll,
        estimatedItemSize: this.getEstimatedItemSize()
      }, listProps), this.renderRow()) : this.renderNoItemsLabel());
    }
  }]);

  return Table;
}(React.Component);

Table.defaultProps = {
  headerHeight: 30,
  rowHeight: 30,
  onHeaderClick: function onHeaderClick(f) {
    return f;
  },
  onResizeColumn: function onResizeColumn(f) {
    return f;
  },
  onRowClick: function onRowClick(f) {
    return f;
  },
  overflowWidth: 17,
  minColumnWidth: 30,
  dynamicColumnWidth: false,
  noItemsLabel: 'No items'
};
export { Table as default };